
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java写文件时，输出不完整的原因以及解决方法close()或flush() / 憋错料</title>

    <meta name="description" content="java写文件时，输出不完整的原因以及解决方法close()或flush() 在java的IO体系中,写文件通常会用到下面语句 BufferedWriter bw=new BufferedWriter(new FileWriter(&quot;sql语句.txt&quot;)); 用到这个的时候一定不能忘了他的伴侣代码.. bw.close(); 或者 bw.flush(); 实际上,FileWriter在写文件时,会把内容存储到一块缓冲区中,当缓冲区满后,才会把缓冲区中的内容写入文件,内容再继续存到缓冲区,如此反复,而flush()会将内存中的内容强制写到文件中,即使内 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">java写文件时，输出不完整的原因以及解决方法close()或flush()</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在java的IO体系中，写文件通常会用到下面语句</p>
<p>BufferedWriter bw=new BufferedWriter(new FileWriter("sql语句.txt"));</p>
<p>用到这个的时候一定不能忘了他的伴侣代码。。</p>
<p>bw.close();</p>
<p>或者</p>
<p>bw.flush();</p>
<p>实际上，FileWriter在写文件时，会把内容存储到一块缓冲区中，当缓冲区满后，才会把缓冲区中的内容写入文件，内容再继续存到缓冲区，如此反复，而flush()会将内存中的内容强制写到文件中，即使内存没满。这就是为什么最后要调用一次fileWriter.close()，close（）方法里面调用了flush（），这样就可以了。否则就会最后有少部分的内容缺失。特别是写小文件的时候，会出现文件空白，没有内容。<br />这个问题很常见，值得注意。</p>
<p>重源代码中可以看出，flush()中自动调用了close()</p>
<pre>    public void close() throws IOException {
        try {
          flush();
        } catch (IOException ignored) {
        }
        out.close();
    }
</pre>
<p>　　</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-02 17:25:59 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>java写文件时，输出不完整的原因以及解决方法close()或flush()的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49Z79bM.html" rel="bookmark">使用 Java 程序写文件时，记得要 flush&lpar;&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用 Java 程序往磁盘写文件时碰到了这样的问题:文件写不全. 假如内容(StringBuffer/StringBuilder)有 100W 个字符,但是通过 Java 程序写到文件里的却不到 100W ,部分字符不见了. 代码大致是这样的: 1 private void writeToDisk() throws Exception { 2 File file = new File(&quot;FILE_PATH&quot;); 3 OutputStreamWriter osw = null; 4 os			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xrKjQ4.html" rel="bookmark">U盘删除文件时提示&OpenCurlyDoubleQuote;文件或目录损坏且无法读取&rdquo;的解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				U盘删除文件时提示&quot;文件或目录损坏且无法读取&quot;的解决方法 出现原因:在写入或读取文件时,进行复制操作,此时复制到的文件是不完整的!或者移动硬盘/U盘中途被拔出,导致文件损坏 异常现象:被删文件(夹)属性为&quot;只读&quot;,更改属性后删除,出现错误提示:提示文件损坏. DOS下使用rd /s命令强制删除失败,进入到该文件夹下使用del /f命令强制删除失败. 使用冰刃.unlocker等强制粉碎文件工具都提示文件损坏 解决方法:CMD下运行命令&quot; chkdsk /f			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n2vVV0.html" rel="bookmark">java读写文件（可当工具类保存。解决乱码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				//读文件 public static String ReadFile(String path) { File file = new File(path); BufferedReader reader = null; String laststr = &quot;&quot;; try { reader = new BufferedReader(new FileReader(file)); String tempString = null; while ((tempString = reader.read			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPe8E10.html" rel="bookmark">installshield制作的安装包卸载时提示重启动的原因以及解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:installshield制作的安装包卸载时提示重启动的原因以及解决办法 有时候卸载installshield制作的安装包程序,卸载完会提示是否重启电脑以完成所有卸载,产生这个提示的常见原因有如下几种:1. 卸载时,程序正处于运行状态2. 卸载时,程序文件夹处于打开状态3. 卸载时,有文件被别的进程调用,或者在进程中,常见情况如dll在进程中 一般来说解决办法是针对第三种情况的,解决办法是卸载时强制杀进程,比如在OnMaintUIBefore或者OnUninstall里写上强制杀进程的代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmexdBM.html" rel="bookmark">mysql 直接从date 文件夹备份表，还原数据库之后提示 table doesn&grave;t exist的原因和解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				补充:正常情况下,建议数据库备份最好用工具进行备份,通过拷贝数据库表进行数据迁移,不同的环境会出现各种不同的意外问题. 背景:今天在整理一个网站的时候,操作系统由于系统自动更新导致一直出现系统蓝屏死机,唉,悲剧了,于是重新安装了系统 windows server 2008 enterprise 32bit. 详情: 系统安装完成后,重新配置之前那个网站,appache服务配好之后,再配置数据的时候是这样做的,将原来Mysql 文件夹(C:\Windows.old\ProgramData\MySQ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49ZKZnM.html" rel="bookmark">水晶报表 Crystal Report 调用存储过程时出错 找不到表 ，解决方法。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用 CrystalReportViewer1 控件在asp.net的网页上显示报表,如果做报表时调用数据表数据的方式调用是可以成功的,但报表是用存储过程获取数据方式会出现以下错误: 找不到表'RptOpenCheck;1' . 文件 G:\TEMP\FO-OpenCheck {6D191F06-DECF-4A25-88FC-8553E3D435AA}.rpt 内出错: 找不到表. Error: 未将对象引用设置到对象的实例. The table 'RptOpenCheck;1' could no			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35VBwE4.html" rel="bookmark">Hyper-V虚拟机启动时报&amp;ldquo&semi;账户没有足够的权限打开VHD文件&amp;rdquo&semi;原因及解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前段时间,准备做一套Exchange Server 2010仿真环境,用于后期企业内各项变更及平台上线时测试工作,由于需要准备的服务器较多,一台一台装虚机,感谢非常费时间,所以想到,做一个模版来快速完成虚拟机部署工作,大概的过程我想大家也有做过,就是装一台Hyper-V虚机,然后把VHD硬盘文件拷贝出来,分别替换所有建好没有系统的虚拟机硬盘,看似简单,但是在实际操作时发现,模版硬盘没有被识别?各种报错,如下图所示: 当看到上图所示这些报错时,很不理解,已经将这台机器的VHD文件指向了新拷入的模版			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35l6Pv0.html" rel="bookmark">关于javac编译时出现&OpenCurlyDoubleQuote;非法字符：&bsol;65279&rdquo;的解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一般用UE或记事本编辑过的UTF-8的文件头会加入BOM标识,该标识由3个char组成.在UTF-8的标准里该BOM标识是可有可无的,Sun 的javac 在编译带有BOM的UTF-8的格式的文件时会出现&quot;非法字符:\65279&quot;的错误,但是用Eclipse进行编译却没有问题,原因在于Eclipse使用的是自己的JDT,而非javac,关于JDT的描述可以到eclipse的官网上去查看. 出现这种情况时,有两种解决方法: a) 利用UE.Editplus等文本编辑器重新保存文件为不带B			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz11L84.html" rel="bookmark">【Mongodb教程 第一课补加课2 】MongoDB下，启动服务时，出现&OpenCurlyDoubleQuote;服务没有响应控制功能&rdquo;解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如图,如果通过下列代码,添加服务后,使用net start命令出现这样的问题时,可以参考下我的解决方法. D:\MongoDB&gt;mongod --dbpath D:\MongoDB\Data --logpath D:\MongoDB\Log\MongoDB.log --logappend --serviceName MongoDB --auth --install 解决方法: 出现这个问题一般是路径有问题. 1)请注意你所有的路径没有错,包括mongod所在路径,日志所在路径等: 2)不要加入多			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXx7bM.html" rel="bookmark" class="title">3&period;不同类型变量存取</a>
					<div>
						public class TestType { public static void main(String[] args) { double score = 98.5; String name =  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4peLqVM.html" rel="bookmark" class="title">纯CSS3实现不错的表单验证效果</a>
					<div>
						这是补充HTML5基础知识的系列内容,其他为: 一.HTML5-- 新的结构元素 二.HTML5-- figure.time.details.mark 三.HTML5-- details活学活用 四. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kD66j3.html" rel="bookmark" class="title">JDBC使用步骤</a>
					<div>
						JDBC编程步骤 加载驱动程序:Class.forName(driverClass) 加载Mysql驱动:Class.forName(&quot;com.mysql.jdbc.Driver&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgPqGN0.html" rel="bookmark" class="title">HTML5中的时间类型，另外EL表达式的时间值来读取时间，并且还可以更改时间</a>
					<div>
						HTML5规范里只规定date新型input输入类型,并没有规定日历弹出框的实现和样式.所以,各浏览器根据自己的设计实现日历.目前只有谷歌浏览器完全实现日历功能.相信这种局面很快就会结束,所有的浏览器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vQjmX0.html" rel="bookmark" class="title">THINKPHP&lowbar;动态验证validate&lpar;&rpar;</a>
					<div>
						$data=I('post.','','trim');$rules = array(     array('name','','数据名称已存在',0,'unique',1),      //array ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aO6Nq4.html" rel="bookmark" class="title">new操作符</a>
					<div>
						1,new操作符实际上包含三部分:operator new分配内存和调用构造函数初始化刚刚分配的内存,类型转换刚刚的指针. string* ps = new string(&quot;lalalala ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nkwj73.html" rel="bookmark" class="title">OC的分类</a>
					<div>
						1 分类就是类的补充和扩展,本质上是类的一部分,把一个类分成若干部分,每个部分就是分类. 2 语法 * 文件中的语法@interface 主类类名(分类类名) * 文件名通常为:主类名+分类名 * 调 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/498xvX3.html" rel="bookmark" class="title">再谈自主开发与企业IT管理</a>
					<div>
						前两天写&lt;自主开发与带兵打仗&gt;分析了一下自主开发的利与弊,得到了园内不少朋友的反馈,但我觉得还有很多东西没有交待清楚,可能有很多朋友也跟我一样在公司的IT部门,有自己的研发团队也有很多外购 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NqokV3.html" rel="bookmark" class="title">meta标签大全</a>
					<div>
						meta标签大全 &lt;!-- x-ua-compatible(浏览器兼容模式) 仅对IE8+以效 告诉浏览器以什么版本的IE的兼容模式来显示网页 &lt;meta http-equiv=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zEDXM.html" rel="bookmark" class="title">数据结构 队列（带尾节点的单链表实现） 回顾练习</a>
					<div>
						带尾节点的单链表队列 入队0(1) 出队0(1) 1 #!/usr/bin/env python3 2 3 class QueueUnderflow(ValueError): 4 pass 5 6 c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekZQD4.html" rel="bookmark" class="title">keepalived&period;sh</a>
					<div>
						1.keepalived.conf主 ! Configuration File for keepalived global_defs { notification_email { [email pro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38bz91M.html" rel="bookmark" class="title">IOS页面（控制器之间）传值之Block</a>
					<div>
						B要传值给A 1.控制器B中要有一个Block: typedef void (^MyBlock)(NSString* str1,NSString* str2); str1和str2里存放着要传递的参数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bRy590.html" rel="bookmark" class="title">List Distinct</a>
					<div>
						list集合的去重操作 代码 class ListDistinctDemo { static void Main(string[] args) { List&lt;Person&gt; personL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvV6v3.html" rel="bookmark" class="title">Unit 06 实际接触工作</a>
					<div>
						单词 apply              申请 contact            联系 immediately        马上 possess            拥有 pay       ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pLwjP4.html" rel="bookmark" class="title">Java值传递</a>
					<div>
						对于Java的值传递, 你真的了解么? Java里面只有值传递, 这个值是什么? 如果是基本数据类型. 你也许回答的很干脆. 但如果是Object对象呢? 你确定清楚不? 先看下code. Java代 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klpvL3.html" rel="bookmark" class="title">ASP&period;NET的运行原理与运行机制</a>
					<div>
						http://kb.cnblogs.com/page/75702/ 当一个HTTP请求到服务器并被IIS接收到之后,IIS首先通过客户端请求的页面类型为其加载相应的.dll文件,然后在处理过程中将这条 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEjpVQ0.html" rel="bookmark" class="title">msqlserver 千万级别单表数据去掉重复记录使用临时表</a>
					<div>
						由于上周末小写把数据数据重复写入数据库,没办法,得去重! 最新使用的语句: use data set nocount ondelete DoRecordProperty from( select TI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgY6xB3.html" rel="bookmark" class="title">shell用到的命令</a>
					<div>
						一．shift 参数左移 until [ $# -eq 0 ]doecho &quot;第一个参数为: $1 参数个数为: $#&quot;shiftdone 二．wc 该命令用于统计指定文件中的字节 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lDzlZ0.html" rel="bookmark" class="title">grep用法简介之一</a>
					<div>
						grep是Linux中个非常重要也是经常使用的文本搜索工具,最近又回顾学习了一遍,趁热自己总结一下. Linux中关于grep的命令一共有三个(以centos6.4为例) grep  :只支持基本正则 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a6exq3.html" rel="bookmark" class="title">Linux中samba服务器的搭建</a>
					<div>
						使用的vmware12虚拟机安装的centos6.8和物理机上的windows10,实现在windows10 上访问CentOs上的samba服务. 一.先查看系统中是否安装有samba服务相关的软件 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
